diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
index 3bd050f7a..c5a46949c 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/CompiledBlockModelMojangData.java
@@ -223,227 +233,170 @@ public class CompiledBlockModelMojangData {
                 float minV = f.v1 * BLOCKS_PER_UNIT;
                 float maxV = f.v2 * BLOCKS_PER_UNIT;
 
-                tintIndices[i] = f.tintIndex;
-                cullfaces[i] = f.cullFace;
-                directions[i] = d;
-                textures[i] = f.texture;
-                int offset = i * 4 * FLOATS_PER_VERTEX;
-                int rot = 4 - f.rotation;
+                this.tintIndices[i] = f.tintIndex;
+                this.cullfaces[i] = f.cullFace;
+                this.directions[i] = d;
+                this.textures[i] = data.textures.getOrDefault(f.texture, BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED);
+                int vertexIndex = i * 4;
+                int rot = 4 - (f.rotation / 90);
                 switch (d) {
                     case UP:
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
+                        this.faceUps[i] = new Vector3f(0, 0, 1);
+                        this.faceLefts[i] = new Vector3f(1, 0, 0);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_LEFT] = new Vector3d(this.maxX, this.maxY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_LEFT + rot) & 0b11)] = new Vector2f(maxU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_RIGHT] = new Vector3d(this.minX, this.maxY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_RIGHT + rot) & 0b11)] = new Vector2f(minU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_RIGHT] = new Vector3d(this.minX, this.maxY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_RIGHT + rot) & 0b11)] = new Vector2f(minU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_LEFT] = new Vector3d(this.maxX, this.maxY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_LEFT + rot) & 0b11)] = new Vector2f(maxU, minV);
                         break;
                     case DOWN:
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
+                        this.faceUps[i] = new Vector3f(0, 0, 1);
+                        this.faceLefts[i] = new Vector3f(-1, 0, 0);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_LEFT] = new Vector3d(this.minX, this.minY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_LEFT + rot) & 0b11)] = new Vector2f(minU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_RIGHT] = new Vector3d(this.maxX, this.minY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_RIGHT + rot) & 0b11)] = new Vector2f(maxU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_RIGHT] = new Vector3d(this.maxX, this.minY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_RIGHT + rot) & 0b11)] = new Vector2f(maxU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_LEFT] = new Vector3d(this.minX, this.minY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_LEFT + rot) & 0b11)] = new Vector2f(minU, maxV);
                         break;
                     case NORTH:
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
+                        this.faceUps[i] = new Vector3f(-1, 0, 0);
+                        this.faceLefts[i] = new Vector3f(0, 1, 0);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_LEFT] = new Vector3d(this.minX, this.maxY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_LEFT + rot) & 0b11)] = new Vector2f(maxU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_RIGHT] = new Vector3d(this.minX, this.minY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_RIGHT + rot) & 0b11)] = new Vector2f(maxU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_RIGHT] = new Vector3d(this.maxX, this.minY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_RIGHT + rot) & 0b11)] = new Vector2f(minU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_LEFT] = new Vector3d(this.maxX, this.maxY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_LEFT + rot) & 0b11)] = new Vector2f(minU, minV);
                         break;
                     case SOUTH:
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
+                        this.faceUps[i] = new Vector3f(0, 1, 0);
+                        this.faceLefts[i] = new Vector3f(-1, 0, 0);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_LEFT] = new Vector3d(this.minX, this.maxY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_LEFT + rot) & 0b11)] = new Vector2f(minU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_RIGHT] = new Vector3d(this.maxX, this.maxY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_RIGHT + rot) & 0b11)] = new Vector2f(maxU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_RIGHT] = new Vector3d(this.maxX, this.minY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_RIGHT + rot) & 0b11)] = new Vector2f(maxU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_LEFT] = new Vector3d(this.minX, this.minY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_LEFT + rot) & 0b11)] = new Vector2f(minU, maxV);
                         break;
                     case WEST:
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = minX;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
+                        this.faceUps[i] = new Vector3f(0, 0, 1);
+                        this.faceLefts[i] = new Vector3f(0, 1, 0);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_LEFT] = new Vector3d(this.minX, this.maxY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_LEFT + rot) & 0b11)] = new Vector2f(maxU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_RIGHT] = new Vector3d(this.minX, this.minY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_RIGHT + rot) & 0b11)] = new Vector2f(maxU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_RIGHT] = new Vector3d(this.minX, this.minY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_RIGHT + rot) & 0b11)] = new Vector2f(minU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_LEFT] = new Vector3d(this.minX, this.maxY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_LEFT + rot) & 0b11)] = new Vector2f(minU, minV);
                         break;
                     case EAST:
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_TOP_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_TOP_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
-
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = maxZ;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = minU;
-                        vertexData[offset + ((VERTEX_TOP_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = maxY;
-                        vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_BOTTOM_RIGHT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = minV;
-
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] = maxX;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] = minY;
-                        vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] = minZ;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_U] = maxU;
-                        vertexData[offset + ((VERTEX_BOTTOM_LEFT + rot) % 4 * FLOATS_PER_VERTEX) + VERTEX_FLOAT_V] = maxV;
+                        this.faceUps[i] = new Vector3f(0, 0, 1);
+                        this.faceLefts[i] = new Vector3f(0, -1, 0);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_LEFT] = new Vector3d(this.maxX, this.minY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_LEFT + rot) & 0b11)] = new Vector2f(minU, maxV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_TOP_RIGHT] = new Vector3d(this.maxX, this.maxY, this.maxZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_TOP_RIGHT + rot) & 0b11)] = new Vector2f(minU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_RIGHT] = new Vector3d(this.maxX, this.maxY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_RIGHT + rot) & 0b11)] = new Vector2f(maxU, minV);
+
+                        this.vertexPoses[vertexIndex + VERTEX_BOTTOM_LEFT] = new Vector3d(this.maxX, this.minY, this.minZ);
+                        this.vertexUvs[vertexIndex + ((VERTEX_BOTTOM_LEFT + rot) & 0b11)] = new Vector2f(maxU, maxV);
                         break;
                 }
                 i++;
             }
 
+            for (int f = 0; f < this.faces; f++) {
+                int offset = f * 4;
+                Vector3dc br = this.vertexPoses[offset + VERTEX_BOTTOM_RIGHT];
+                Vector3dc bl = this.vertexPoses[offset + VERTEX_BOTTOM_LEFT];
+                Vector3dc tr = this.vertexPoses[offset + VERTEX_TOP_RIGHT];
+
+                Vector3d a = br.sub(bl, new Vector3d());
+                Vector3d b = tr.sub(bl, new Vector3d());
+
+                this.faceNormals[f] = new Vector3f(a.cross(b, new Vector3d())).normalize();
+            }
+
             if (element.rotation != null) {
-                for (int f = 0; f < faces; f++) {
+                for (int f = 0; f < this.faces; f++) {
                     for (int v = 0; v < 4; v++) {
-                        final int offset = f * 4 * FLOATS_PER_VERTEX + v * FLOATS_PER_VERTEX;
-                        final float x = vertexData[offset + VERTEX_FLOAT_X] - element.rotation.originX * BLOCKS_PER_UNIT;
-                        final float y = vertexData[offset + VERTEX_FLOAT_Y] - element.rotation.originY * BLOCKS_PER_UNIT;
-                        final float z = vertexData[offset + VERTEX_FLOAT_Z] - element.rotation.originZ * BLOCKS_PER_UNIT;
-                        final float nx;
-                        final float ny;
-                        final float nz;
-                        final float sin = MathHelper.sin(MathHelper.toRadians(element.rotation.angle));
-                        final float cos = MathHelper.cos(MathHelper.toRadians(element.rotation.angle));
+                        final int offset = f * 4 + v;
                         switch (element.rotation.axis) {
                             case X:
-                                nx = x;
-                                ny = y * cos - z * sin;
-                                nz = z * cos + y * sin;
+                                this.vertexPoses[offset] = this.vertexPoses[offset]
+                                    .sub(element.rotation.originX * BLOCKS_PER_UNIT, element.rotation.originY * BLOCKS_PER_UNIT, element.rotation.originZ * BLOCKS_PER_UNIT, new Vector3d())
+                                    .rotateX(MathHelper.toRadians(element.rotation.angle))
+                                    .add(element.rotation.originX * BLOCKS_PER_UNIT, element.rotation.originY * BLOCKS_PER_UNIT, element.rotation.originZ * BLOCKS_PER_UNIT);
                                 break;
                             case Y:
-                                nx = x * cos - z * sin;
-                                ny = y;
-                                nz = z * cos + x * sin;
+                                this.vertexPoses[offset] = this.vertexPoses[offset]
+                                    .sub(element.rotation.originX * BLOCKS_PER_UNIT, element.rotation.originY * BLOCKS_PER_UNIT, element.rotation.originZ * BLOCKS_PER_UNIT, new Vector3d())
+                                    .rotateY(MathHelper.toRadians(element.rotation.angle))
+                                    .add(element.rotation.originX * BLOCKS_PER_UNIT, element.rotation.originY * BLOCKS_PER_UNIT, element.rotation.originZ * BLOCKS_PER_UNIT);
                                 break;
                             case Z:
                             default:
-                                nx = x * cos - y * sin;
-                                ny = y * cos + x * sin;
-                                nz = z;
+                                this.vertexPoses[offset] = this.vertexPoses[offset]
+                                    .sub(element.rotation.originX * BLOCKS_PER_UNIT, element.rotation.originY * BLOCKS_PER_UNIT, element.rotation.originZ * BLOCKS_PER_UNIT, new Vector3d())
+                                    .rotateZ(MathHelper.toRadians(element.rotation.angle))
+                                    .add(element.rotation.originX * BLOCKS_PER_UNIT, element.rotation.originY * BLOCKS_PER_UNIT, element.rotation.originZ * BLOCKS_PER_UNIT);
                                 break;
                         }
-                        vertexData[offset + VERTEX_FLOAT_X] = nx + element.rotation.originX * BLOCKS_PER_UNIT;
-                        vertexData[offset + VERTEX_FLOAT_Y] = ny + element.rotation.originY * BLOCKS_PER_UNIT;
-                        vertexData[offset + VERTEX_FLOAT_Z] = nz + element.rotation.originZ * BLOCKS_PER_UNIT;
                     }
-                }
-            }
-
-            for (int f = 0; f < faces; f++) {
-                int offset = f * 4 * FLOATS_PER_VERTEX;
-                float ax = vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] - vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X];
-                float ay = vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] - vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y];
-                float az = vertexData[offset + (VERTEX_BOTTOM_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] - vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z];
-
-                float bx = vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X] - vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_X];
-                float by = vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y] - vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Y];
-                float bz = vertexData[offset + (VERTEX_TOP_RIGHT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z] - vertexData[offset + (VERTEX_BOTTOM_LEFT * FLOATS_PER_VERTEX) + VERTEX_FLOAT_Z];
-
-                float nx = (ay * bz) - (az * by);
-                float ny = (az * bx) - (ax * bz);
-                float nz = (ax * by) - (ay * bx);
-
-                float length = MathHelper.sqrt_float(nx * nx + ny * ny + nz * nz);
-
-                nx /= length;
-                ny /= length;
-                nz /= length;
 
-                normalData[f * FLOATS_PER_NORMAL + NORMAL_FLOAT_X] = nx;
-                normalData[f * FLOATS_PER_NORMAL + NORMAL_FLOAT_Y] = ny;
-                normalData[f * FLOATS_PER_NORMAL + NORMAL_FLOAT_Z] = nz;
+                    switch (element.rotation.axis) {
+                        case X -> {
+                            this.faceUps[f] = this.faceUps[f].rotateX(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                            this.faceLefts[f] = this.faceLefts[f].rotateX(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                            this.faceNormals[f] = this.faceNormals[f].rotateX(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                        }
+                        case Y -> {
+                            this.faceUps[f] = this.faceUps[f].rotateY(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                            this.faceLefts[f] = this.faceLefts[f].rotateY(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                            this.faceNormals[f] = this.faceNormals[f].rotateY(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                        }
+                        case Z -> {
+                            this.faceUps[f] = this.faceUps[f].rotateZ(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                            this.faceLefts[f] = this.faceLefts[f].rotateZ(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                            this.faceNormals[f] = this.faceNormals[f].rotateZ(org.joml.Math.toRadians(element.rotation.angle), new Vector3f());
+                        }
+                    }
+                }
             }
         }
     }
